﻿package  {
	import Box2D.Collision.b2AABB;
	import Box2D.Collision.b2Bound;
	import Box2D.Collision.Shapes.b2CircleDef;
	import Box2D.Collision.Shapes.b2PolygonDef;
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import Box2D.Dynamics.b2BodyDef;
	import Box2D.Dynamics.b2DebugDraw;
	import Box2D.Dynamics.b2World;
	import Box2D.Dynamics.Joints.b2DistanceJoint;
	import Box2D.Dynamics.Joints.b2DistanceJointDef;
	import Box2D.Dynamics.Joints.b2MouseJoint;
	import Box2D.Dynamics.Joints.b2MouseJointDef;
	import fl.controls.Button;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextFormat;
	

	public class Main extends Sprite {

		private var world:b2World;		
		private var ball:Array;		
		private var joint:Array;
		
		private var buttonArray:Array;
		
		public function Main():void {
			
			stageInit();

			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
						
			buttonArray = new Array();
			createButton("reset", reset, 10);
			var btn:Button = buttonArray[0];
			btn.enabled = false;			
			
			createButton("1-0", start10, 70);
			createButton("2-0", start20, 130);
			createButton("3-0", start30, 190);
			createButton("1-1", start11, 250);
			createButton("2-1", start21, 310);
			
		}

		private function reset(event:MouseEvent):void {

			
			for (var i:uint = 0; i < 5; i++ ) {
				world.DestroyJoint(joint[i]);
				world.DestroyBody(ball[i]);
//				joint[i] = null;
//				ball[i] = null;
			}			
			
			stageInit();
			
			buttonArray[0].enabled = false;
			for (i = 1; i < 6; i++ )
				buttonArray[i].enabled = true;
			
		}
		
		
		private function start10(event:MouseEvent):void {
			ball[0].ApplyForce(new b2Vec2( -500, 0), new b2Vec2(0, 4));			
			
			buttonArray[0].enabled = true;
			for (var i:uint = 1; i < 6; i++ )
				buttonArray[i].enabled = false;
		}

		private function start20(event:MouseEvent):void {
			ball[0].ApplyForce(new b2Vec2(-500, 0), new b2Vec2(0, 4));			
			ball[1].ApplyForce(new b2Vec2(-500, 0), new b2Vec2(0, 4));			

			buttonArray[0].enabled = true;
			for (var i:uint = 1; i < 6; i++ )
				buttonArray[i].enabled = false;

		}
		
		private function start11(event:MouseEvent):void {
			ball[0].ApplyForce(new b2Vec2(-500, 0), new b2Vec2(0, 4));			
			ball[4].ApplyForce(new b2Vec2(500, 0), new b2Vec2(0, 4));			
			
			buttonArray[0].enabled = true;
			for (var i:uint = 1; i < 6; i++ )
				buttonArray[i].enabled = false;
			
		}
		
		private function start21(event:MouseEvent):void {
			ball[0].ApplyForce(new b2Vec2(-500, 0), new b2Vec2(0, 4));			
			ball[1].ApplyForce(new b2Vec2( -500, 0), new b2Vec2(0, 4));			
			ball[4].ApplyForce(new b2Vec2( 500, 0), new b2Vec2(0, 4));	
			
			buttonArray[0].enabled = true;
			for (var i:uint = 1; i < 6; i++ )
				buttonArray[i].enabled = false;
			
			
		}
		
		private function start30(event:MouseEvent):void {
			ball[0].ApplyForce(new b2Vec2(-500, 0), new b2Vec2(0, 4));			
			ball[1].ApplyForce(new b2Vec2( -500, 0), new b2Vec2(0, 4));			
			ball[2].ApplyForce(new b2Vec2( -500, 0), new b2Vec2(0, 4));			
			
			buttonArray[0].enabled = true;
			for (var i:uint = 1; i < 6; i++ )
				buttonArray[i].enabled = false;
			
			
		}		
		
		
		private function createButton(str:String, handler:Function, pos:uint):void {
			
			var button:Button = new Button();
/*			
			var myTxFmt:TextFormat = new TextFormat();
			myTxFmt.size = 45;
			button.textField.setTextFormat(myTxFmt);			
			button.textField.text = str;
*/			
			
			button.label = str;
			button.addEventListener(MouseEvent.CLICK, handler);
			button.setSize(50, 20);
			button.move(pos + 20, 550);
				
			addChild(button);
			buttonArray.push(button);
			
		}
			
			
		private function stageInit():void {

			var worldAABB:b2AABB = new b2AABB();
			worldAABB.lowerBound.Set(-100, -100);
			worldAABB.upperBound.Set(100, 100);
			
			var gravity:b2Vec2 = new b2Vec2(0, 9);
			
			world = new b2World(worldAABB, gravity, false);
			
			
			setBall();
			
			////////////////////////////////////////
			// 描画設定
			
			var debugDraw:b2DebugDraw = new b2DebugDraw();
			debugDraw.m_sprite = this;
			debugDraw.m_drawScale = 100; // 1mを100ピクセルにする
			debugDraw.m_fillAlpha = 0.5; // 不透明度
			debugDraw.m_lineThickness = 3; // 線の太さ
			debugDraw.m_drawFlags = b2DebugDraw.e_shapeBit | b2DebugDraw.e_jointBit;
			world.SetDebugDraw(debugDraw);
			
			
			var contactListener:ContactListener = new ContactListener();
			contactListener.load();
			world.SetContactListener(contactListener);			
			
		}
		
		private function setBall():void {
			
			var floorBodyDef:b2BodyDef = new b2BodyDef();
			floorBodyDef.position.Set(3, -10);
			
			var floorShapeDef:b2PolygonDef = new b2PolygonDef();
			floorShapeDef.SetAsBox(5, 0.1);
			var floor:b2Body = world.CreateBody(floorBodyDef);
			floor.CreateShape(floorShapeDef);

			
			
			ball = new Array();
			joint = new Array();
			
			for (var i:uint = 0; i < 5; i++ ) {
				
				var starDef:b2BodyDef = new b2BodyDef();
				starDef.position.Set(2 + i, 4);
	
				var starShapeDef:b2CircleDef = new b2CircleDef();
				starShapeDef.radius = 0.48;
				starShapeDef.restitution = 1.0;
				starShapeDef.density = 15;
				starShapeDef.friction = 0;
			
				var star:b2Body = world.CreateBody(starDef);
				star.CreateShape(starShapeDef);
				star.SetMassFromShapes();
				star.WakeUp();
				
			
				var jointDef:b2DistanceJointDef = new b2DistanceJointDef();
				jointDef.Initialize(star, floor, star.GetWorldCenter(), new b2Vec2(2 + i, 0.5));
				jointDef.collideConnected = true;
				world.CreateJoint(jointDef);
				
				var jt:b2DistanceJoint = new b2DistanceJoint(jointDef);
	
				ball.push(star);
				joint.push(jt);
			}


		}
		
		
		private function enterFrameHandler(event:Event):void {
			if (world == null) {
				return;
			}
			world.Step(1 / 24, 10);
		}
	}
}
